/*
    WPX - Include file for WPX.C and WPXDLL.C
    Copyright (c) 1995-2003 Alessandro Scotti
    http://www.walkofmind.com

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#ifndef _WPX_H_
#define _WPX_H_

/* Macros */
#define NOREF(a)        ((VOID)a)   // Avoid "parameter not used" warning

/* Window classes and names */
#define WORDPADCLASSNAME    "WordPadClass"
#define RICHEDITCLASSNAME   "RICHEDIT"
#define AFXBARCLASSNAME     "AfxControlBar"
#define WPXCLASSNAME        "WPX_Window_Class"
#define WPXWINDOWNAME       "WPX_Hook_Window"
#define WPXMUTEXNAME        "WPX_Instance_Mutex"

/* Private messages */
#define PM_BASE                 (WM_USER+0x2000)
#define PM_INSERTWINDOW         (PM_BASE+1)
#define PM_REMOVEWINDOW         (PM_BASE+2)
#define PM_SUBCLASSWINDOW       (PM_BASE+3)
#define PM_UNSUBCLASSWINDOW     (PM_BASE+4)
#define PM_INITGUI              (PM_BASE+5)
#define PM_GETMSGHOOK           (PM_BASE+6)
#define PM_GETSHELLHOOK         (PM_BASE+7)
#define PM_DLGGETTEXTINFO       (PM_BASE+8)

/* Menu identifiers */
#define IDM_BASE                0x4000
#define IDM_TEXTINFO            (IDM_BASE+1)
#define IDM_BACKCOLOR           (IDM_BASE+2)
#define IDM_ABOUT               (IDM_BASE+3)

/* Character classes */
#define CCLS_WORD               1   // A character that is valid in a word
#define CCLS_BLANK              2   // Blank
#define CCLS_BREAK              3   // Physical line break (CR or LF)
#define CCLS_OTHER              4   // None of the above

#define PROGRESS_STEPS          64

/* Text information structure */
typedef struct {
    DWORD   dwLength;
    DWORD   dwLengthNoBlanks;
    DWORD   dwParagraphs;
    DWORD   dwLines;
    DWORD   dwWords;
    DWORD   dwOLEObjects;
    DWORD   dwOLELinks;
    /* Fields used by the enumeration callback */
    DWORD   dwCurChar;      // Index of current char relative to whole length
    BOOL    boInWord;       // TRUE if currently inside a word
    BOOL    boInPara;       // TRUE if currently inside a paragraph
    HWND    hWndProgress;   // Handle of progress bar
    DWORD   dwProgressStepSize; // Size of one progress bar step (characters)
} WPXTEXTINFO;

/* Function prototypes */
HHOOK CALLBACK wpxInitMsgHook( DWORD dwThreadId );
HHOOK CALLBACK wpxInitShellHook( DWORD dwThreadId );
BOOL CALLBACK wpxTermMsgHook( void );
BOOL CALLBACK wpxTermShellHook( void );

#endif /* _WPX_H_ */
